#include <iostream>
#include <fstream>
#include <string.h>
#include <stdlib.h>
#include <math.h>

using namespace std;

int main()
{
    ifstream fin ;
    ofstream fout ;
    int N , C ;
    int i , j , k , l  ;
    const int maxn = 350 ;
    const int maxc = 500 ;
    const char _VCHAR = '1' ;

    int lwrk ,  lmax , xmax , ymax , midx , midy  ;
    int constN ;

    int **matrix ;
    char **matrixf , **inner , **mat;
    int **curent_qu , pointer_curent_qu ;
    int **temp_qu ,  pointer_temp_qu ;
    int *decision ,  count ;
    int *lengthcolor , color ;
    int  maxcolorlength , maxcurentcolor, max  ;



    fin.open ("flood-it.in" ) ;
    if ( !fin )  { cout << "Can't open flood-it.in" << endl  ; return 1 ;}
    fin >> N  >> C  ;
    if ( N > maxn || N < 2 || C <  2 || C > maxc ) {
      cout << "error input data " << endl ;
      fin.close() ;
      return 1 ;
    }


    matrix = new int* [N] ;
    matrixf = new char* [N] ;
    mat = new char* [N] ;
    inner = new char* [N] ;
    curent_qu = new int* [N*N];
    temp_qu = new int* [N*N];
    decision = new int [N*N] ;
    lengthcolor = new int[C+1] ;



    for( int i = 0 ; i < N ; i++ ){
        matrix[i] = new int[N] ;
        matrixf[i] = new char[N] ;
        mat[i] = new char[N] ;
        inner[i] = new char[N] ;
    }

    for ( int i = 0 ; i < N * N ; i++ ) {
        curent_qu[i] = new int[2] ;
        temp_qu[i] = new int[2] ;
    }


    for ( i=0 ; i < N ; i++ )
        for ( j=0 ; j < N ; j++ )
            fin >>  matrix[i][j] ;
    fin.close() ;


    xmax = ymax = 0 ;
    lmax =  N * N / 30 ;
    matrixf[0][0] =  '0' ;
    max = 0 ;
    constN =   log ( N )    ;

    for ( i=0 ; i < N ; i++ )
        for ( j=0 ; j < N ; j++ ) {
            if ( matrixf[i][j] == '1') continue ;
            for ( k=0 ; k<N ; ++k )  memset ( matrixf[k] , '0' , N  ) ;
            pointer_curent_qu = 0 ;
            curent_qu[pointer_curent_qu][0] = i ;
            curent_qu[pointer_curent_qu][1] = j ;
            matrixf[i][j] = '1' ;
            for ( k = 0 ; k <=  pointer_curent_qu ; k++ ) {
               if ( curent_qu[k][0] -1 >= 0  &&
                    matrixf[curent_qu[k][0] -1][curent_qu[k][1]] == '0' &&
                    matrix[curent_qu[k][0]][curent_qu[k][1]] ==
                    matrix [curent_qu[k][0] -1][curent_qu[k][1]] )  {
                        ++pointer_curent_qu ;
                        curent_qu[pointer_curent_qu][0] = curent_qu[k][0] -1 ;
                        curent_qu[pointer_curent_qu][1] = curent_qu[k][1] ;
                        matrixf[curent_qu[k][0] -1][curent_qu[k][1]] = '1' ;
               }
               if ( curent_qu[k][0] + 1 < N  &&
                    matrixf[curent_qu[k][0] + 1][curent_qu[k][1]] == '0'  &&
                    matrix[curent_qu[k][0]][curent_qu[k][1]] ==
                    matrix[curent_qu[k][0] + 1][curent_qu[k][1]] )  {
                        ++pointer_curent_qu ;
                        curent_qu[pointer_curent_qu][0] = curent_qu[k][0]  + 1 ;
                        curent_qu[pointer_curent_qu][1] = curent_qu[k][1] ;
                        matrixf[curent_qu[k][0] + 1][curent_qu[k][1]] = '1' ;
               }
               if ( curent_qu[k][1] + 1 < N  &&
                    matrixf[curent_qu[k][0] ][curent_qu[k][1]+1] == '0'   &&
                    matrix[curent_qu[k][0]][curent_qu[k][1]] ==
                    matrix[curent_qu[k][0] ][curent_qu[k][1]+1] )  {
                        ++pointer_curent_qu ;
                        curent_qu[pointer_curent_qu][0] = curent_qu[k][0] ;
                        curent_qu[pointer_curent_qu][1] = curent_qu[k][1] + 1;
                        matrixf[curent_qu[k][0] ][curent_qu[k][1] + 1 ] = '1' ;
               }
               if ( curent_qu[k][1] -1 >= 0 &&
                    matrixf[curent_qu[k][0] ][curent_qu[k][1]-1] == '0'  &&
                    matrix[curent_qu[k][0]][curent_qu[k][1]] ==
                    matrix[curent_qu[k][0]][curent_qu[k][1]-1] )  {
                        ++pointer_curent_qu ;
                        curent_qu[pointer_curent_qu][0] = curent_qu[k][0]  ;
                        curent_qu[pointer_curent_qu][1] = curent_qu[k][1] -1 ;
                        matrixf[curent_qu[k][0] ][curent_qu[k][1]-1] = '1' ;
               }
            }   // end of curent_qu



            for ( k=1; k <= C ; k++ )    lengthcolor[k] = 0 ;

            for ( k=0 ; k <= pointer_curent_qu ; k++ ) {
               if ( curent_qu[k][0] -1 >= 0  && matrixf[curent_qu[k][0] -1][curent_qu[k][1]] == '0' ) {
                    matrixf[curent_qu[k][0] -1][curent_qu[k][1]] =  _VCHAR ;
                    color = matrix[curent_qu[k][0] -1][curent_qu[k][1]] ;
                    ++lengthcolor[color] ;
                    pointer_temp_qu = 0 ;
                    temp_qu[pointer_temp_qu][0] = curent_qu[k][0] -1 ;
                    temp_qu[pointer_temp_qu][1] = curent_qu[k][1]  ;
                    for ( l = 0 ; l <=  pointer_temp_qu ; l++ ) {
                        if (temp_qu[l][0] -1 >= 0  &&
                    	    matrixf[temp_qu[l][0] -1][temp_qu[l][1]] == '0' &&
                    	    color == matrix [temp_qu[l][0] -1][temp_qu[l][1]] )  {
                            ++pointer_temp_qu ;
                        	temp_qu[pointer_temp_qu][0] = temp_qu[l][0] -1 ;
                        	temp_qu[pointer_temp_qu][1] = temp_qu[l][1] ;
                        	matrixf[temp_qu[l][0] -1][temp_qu[l][1]] =  _VCHAR  ;
                            ++lengthcolor[color] ;
                        }
                        if ( temp_qu[l][0] + 1 < N  &&
                    	     matrixf[temp_qu[l][0] + 1][temp_qu[l][1]] == '0'  &&
                    	     color ==  matrix[temp_qu[l][0] + 1][temp_qu[l][1]] )  {
                             ++pointer_temp_qu ;
                             temp_qu[pointer_temp_qu][0] = temp_qu[l][0]  + 1 ;
                             temp_qu[pointer_temp_qu][1] = temp_qu[l][1] ;
                             matrixf[temp_qu[l][0] + 1][temp_qu[l][1]] = _VCHAR ;
                             ++lengthcolor[color] ;
                        }
                        if ( temp_qu[l][1] + 1 < N  &&
                    	    matrixf[temp_qu[l][0] ][temp_qu[l][1]+1] == '0'   &&
                    	    color ==  matrix[temp_qu[l][0] ][temp_qu[l][1]+1] )  {
                            ++pointer_temp_qu ;
                            temp_qu[pointer_temp_qu][0] = temp_qu[l][0] ;
                            temp_qu[pointer_temp_qu][1] = temp_qu[l][1] + 1;
                            matrixf[temp_qu[l][0] ][temp_qu[l][1] + 1 ] = _VCHAR ;
                            ++lengthcolor[color] ;
                        }
                        if ( temp_qu[l][1] -1 >= 0 &&
                            matrixf[temp_qu[l][0] ][temp_qu[l][1]-1] == '0'  &&
                            color ==  matrix[temp_qu[l][0]][temp_qu[l][1]-1] )  {
                            ++pointer_temp_qu ;
                            temp_qu[pointer_temp_qu][0] = temp_qu[l][0]  ;
                            temp_qu[pointer_temp_qu][1] = temp_qu[l][1] -1 ;
                            matrixf[temp_qu[l][0] ][temp_qu[l][1]-1] = _VCHAR ;
                            ++lengthcolor[color] ;
                        }
                    }    // for temp_qu

               }    //end if
               if ( curent_qu[k][0] + 1 < N  && matrixf[curent_qu[k][0] + 1][curent_qu[k][1]] == '0' ) {
                    matrixf[curent_qu[k][0] + 1][curent_qu[k][1]] = _VCHAR ;
                    color = matrix[curent_qu[k][0] + 1][curent_qu[k][1]] ;
                    ++lengthcolor[color] ;
                    pointer_temp_qu = 0 ;
                    temp_qu[pointer_temp_qu][0] = curent_qu[k][0]  + 1 ;
                    temp_qu[pointer_temp_qu][1] = curent_qu[k][1]  ;
                    for ( l = 0 ; l <=  pointer_temp_qu ; l++ ) {
                        if (temp_qu[l][0] -1 >= 0  &&
                    	    matrixf[temp_qu[l][0] -1][temp_qu[l][1]] == '0' &&
                    	    color == matrix [temp_qu[l][0] -1][temp_qu[l][1]] )  {
                            ++pointer_temp_qu ;
                        	temp_qu[pointer_temp_qu][0] = temp_qu[l][0] -1 ;
                        	temp_qu[pointer_temp_qu][1] = temp_qu[l][1] ;
                        	matrixf[temp_qu[l][0] -1][temp_qu[l][1]] = _VCHAR ;
                            ++lengthcolor[color] ;
                        }
                        if ( temp_qu[l][0] + 1 < N  &&
                    	     matrixf[temp_qu[l][0] + 1][temp_qu[l][1]] == '0'  &&
                    	     color ==  matrix[temp_qu[l][0] + 1][temp_qu[l][1]] )  {
                             ++pointer_temp_qu ;
                             temp_qu[pointer_temp_qu][0] = temp_qu[l][0]  + 1 ;
                             temp_qu[pointer_temp_qu][1] = temp_qu[l][1] ;
                             matrixf[temp_qu[l][0] + 1][temp_qu[l][1]] = _VCHAR ;
                             ++lengthcolor[color] ;
                        }
                        if ( temp_qu[l][1] + 1 < N  &&
                    	    matrixf[temp_qu[l][0] ][temp_qu[l][1]+1] == '0'   &&
                    	    color ==  matrix[temp_qu[l][0] ][temp_qu[l][1]+1] )  {
                            ++pointer_temp_qu ;
                            temp_qu[pointer_temp_qu][0] = temp_qu[l][0] ;
                            temp_qu[pointer_temp_qu][1] = temp_qu[l][1] + 1;
                            matrixf[temp_qu[l][0] ][temp_qu[l][1] + 1 ] = _VCHAR;
                            ++lengthcolor[color] ;
                        }
                        if ( temp_qu[l][1] -1 >= 0 &&
                            matrixf[temp_qu[l][0] ][temp_qu[l][1]-1] == '0'  &&
                            color ==  matrix[temp_qu[l][0]][temp_qu[l][1]-1] )  {
                            ++pointer_temp_qu ;
                            temp_qu[pointer_temp_qu][0] = temp_qu[l][0]  ;
                            temp_qu[pointer_temp_qu][1] = temp_qu[l][1] -1 ;
                            matrixf[temp_qu[l][0] ][temp_qu[l][1]-1] = _VCHAR ;
                            ++lengthcolor[color] ;
                        }
                    }    // for temp_qu

               }    //end if
               if ( curent_qu[k][1] -1 >= 0  && matrixf[curent_qu[k][0] ][curent_qu[k][1] -1 ] == '0' ) {
                    matrixf[curent_qu[k][0] ][curent_qu[k][1]- 1] = _VCHAR ;
                    color = matrix[curent_qu[k][0]][curent_qu[k][1] - 1] ;
                    ++lengthcolor[color] ;
                    pointer_temp_qu = 0 ;
                    temp_qu[pointer_temp_qu][0] = curent_qu[k][0]  ;
                    temp_qu[pointer_temp_qu][1] = curent_qu[k][1] -1 ;
                    for ( l = 0 ; l <=  pointer_temp_qu ; l++ ) {
                        if (temp_qu[l][0] -1 >= 0  &&
                    	    matrixf[temp_qu[l][0] -1][temp_qu[l][1]] == '0' &&
                    	    color == matrix [temp_qu[l][0] -1][temp_qu[l][1]] )  {
                            ++pointer_temp_qu ;
                        	temp_qu[pointer_temp_qu][0] = temp_qu[l][0] -1 ;
                        	temp_qu[pointer_temp_qu][1] = temp_qu[l][1] ;
                        	matrixf[temp_qu[l][0] -1][temp_qu[l][1]] = _VCHAR ;
                            ++lengthcolor[color] ;
                        }
                        if ( temp_qu[l][0] + 1 < N  &&
                    	     matrixf[temp_qu[l][0] + 1][temp_qu[l][1]] == '0'  &&
                    	     color ==  matrix[temp_qu[l][0] + 1][temp_qu[l][1]] )  {
                             ++pointer_temp_qu ;
                             temp_qu[pointer_temp_qu][0] = temp_qu[l][0]  + 1 ;
                             temp_qu[pointer_temp_qu][1] = temp_qu[l][1] ;
                             matrixf[temp_qu[l][0] + 1][temp_qu[l][1]] = _VCHAR;
                             ++lengthcolor[color] ;
                        }
                        if ( temp_qu[l][1] + 1 < N  &&
                    	    matrixf[temp_qu[l][0] ][temp_qu[l][1]+1] == '0'   &&
                    	    color ==  matrix[temp_qu[l][0] ][temp_qu[l][1]+1] )  {
                            ++pointer_temp_qu ;
                            temp_qu[pointer_temp_qu][0] = temp_qu[l][0] ;
                            temp_qu[pointer_temp_qu][1] = temp_qu[l][1] + 1;
                            matrixf[temp_qu[l][0] ][temp_qu[l][1] + 1 ] = _VCHAR ;
                            ++lengthcolor[color] ;
                        }
                        if ( temp_qu[l][1] -1 >= 0 &&
                            matrixf[temp_qu[l][0] ][temp_qu[l][1]-1] == '0'  &&
                            color ==  matrix[temp_qu[l][0]][temp_qu[l][1]-1] )  {
                            ++pointer_temp_qu ;
                            temp_qu[pointer_temp_qu][0] = temp_qu[l][0]  ;
                            temp_qu[pointer_temp_qu][1] = temp_qu[l][1] -1 ;
                            matrixf[temp_qu[l][0] ][temp_qu[l][1]-1] = _VCHAR ;
                            ++lengthcolor[color] ;
                        }
                    }    // for temp_qu

                }    //end if
               if ( curent_qu[k][1] +1 < N  && matrixf[curent_qu[k][0] ][curent_qu[k][1] + 1] == '0' ) {
                    matrixf[curent_qu[k][0] ][curent_qu[k][1]+1] = _VCHAR ;
                    color = matrix[curent_qu[k][0] ][curent_qu[k][1]+1] ;
                    ++lengthcolor[color] ;
                    pointer_temp_qu = 0 ;
                    temp_qu[pointer_temp_qu][0] = curent_qu[k][0]  ;
                    temp_qu[pointer_temp_qu][1] = curent_qu[k][1] +1 ;
                    for ( l = 0 ; l <=  pointer_temp_qu ; l++ ) {
                        if (temp_qu[l][0] -1 >= 0  &&
                    	    matrixf[temp_qu[l][0] -1][temp_qu[l][1]] == '0' &&
                    	    color == matrix [temp_qu[l][0] -1][temp_qu[l][1]] )  {
                            ++pointer_temp_qu ;
                        	temp_qu[pointer_temp_qu][0] = temp_qu[l][0] -1 ;
                        	temp_qu[pointer_temp_qu][1] = temp_qu[l][1] ;
                        	matrixf[temp_qu[l][0] -1][temp_qu[l][1]] = _VCHAR ;
                            ++lengthcolor[color] ;
                        }
                        if ( temp_qu[l][0] + 1 < N  &&
                    	     matrixf[temp_qu[l][0] + 1][temp_qu[l][1]] == '0'  &&
                    	     color ==  matrix[temp_qu[l][0] + 1][temp_qu[l][1]] )  {
                             ++pointer_temp_qu ;
                             temp_qu[pointer_temp_qu][0] = temp_qu[l][0]  + 1 ;
                             temp_qu[pointer_temp_qu][1] = temp_qu[l][1] ;
                             matrixf[temp_qu[l][0] + 1][temp_qu[l][1]] = _VCHAR ;
                             ++lengthcolor[color] ;
                        }
                        if ( temp_qu[l][1] + 1 < N  &&
                    	    matrixf[temp_qu[l][0] ][temp_qu[l][1]+1] == '0'   &&
                    	    color ==  matrix[temp_qu[l][0] ][temp_qu[l][1]+1] )  {
                            ++pointer_temp_qu ;
                            temp_qu[pointer_temp_qu][0] = temp_qu[l][0] ;
                            temp_qu[pointer_temp_qu][1] = temp_qu[l][1] + 1;
                            matrixf[temp_qu[l][0] ][temp_qu[l][1] + 1 ] = _VCHAR ;
                            ++lengthcolor[color] ;
                        }
                        if ( temp_qu[l][1] -1 >= 0 &&
                            matrixf[temp_qu[l][0] ][temp_qu[l][1]-1] == '0'  &&
                            color ==  matrix[temp_qu[l][0]][temp_qu[l][1]-1] )  {
                            ++pointer_temp_qu ;
                            temp_qu[pointer_temp_qu][0] = temp_qu[l][0]  ;
                            temp_qu[pointer_temp_qu][1] = temp_qu[l][1] -1 ;
                            matrixf[temp_qu[l][0] ][temp_qu[l][1]-1] =  _VCHAR;
                            ++lengthcolor[color] ;
                        }
                    }    // for temp_qu

                }    //end if



            }  // end of for curent_qu



            maxcolorlength = 0 ;
/*
            if (  _VCHAR == '1')
               for ( k=1 ; k <=  C ; ++k ) {
                 if ( maxcolorlength <  lengthcolor[k] )   maxcolorlength = lengthcolor[k] ;
                 else ;
               }

            else
                 for ( k=1 ; k <=  C ; ++k )          maxcolorlength += lengthcolor[k] ;
*/

            for ( k=1 ; k <=  C ; ++k )
                 if ( maxcolorlength <  lengthcolor[k] )
                   maxcolorlength = lengthcolor[k] ;


            if ( abs (max  -  maxcolorlength - pointer_curent_qu) < constN  ) {
                midx = midy = 0 ;
                for ( k=0 ; k <= pointer_curent_qu ; ++k ) { midx += curent_qu[k][0] ;  midy += curent_qu[k][1] ; }
                midx = midx / ( pointer_curent_qu + 1 ) ;
                midy = midy / ( pointer_curent_qu + 1 ) ;
                lwrk  = (midx-N/2)*(midx-N/2)+(midy-N/2)*(midy-N/2) ;
                if ( lwrk < lmax ) {
                  max  =  maxcolorlength + pointer_curent_qu ;
                  lmax = lwrk ;
                  xmax = curent_qu[0][0] ;
                  ymax = curent_qu[0][1] ;
               }
               continue ;
            }


            if ( max  <  (maxcolorlength + pointer_curent_qu )   ) {
                midx = midy = 0 ;
                for ( k=0 ; k <= pointer_curent_qu ; ++k ) { midx += curent_qu[k][0] ;  midy += curent_qu[k][1] ; }
                midx = midx / ( pointer_curent_qu + 1 ) ;
                midy = midy / ( pointer_curent_qu + 1 ) ;
                lmax  = (midx-N/2)*(midx-N/2)+(midy-N/2)*(midy-N/2) ;
                max  =  maxcolorlength + pointer_curent_qu ;
                xmax = curent_qu[0][0] ;
                ymax = curent_qu[0][1] ;
            }

   }  // end of for


  decision [1] = xmax ;
  decision [2] = ymax ;
  count = 3 ;


  // make max_qu

   pointer_curent_qu = 0 ;
   curent_qu[0][0] = xmax ;
   curent_qu[0][1] = ymax ;


   for ( k=0 ; k<N ; ++k )  {  memset ( inner[k] , '0' , N  ) ;  memset ( matrixf[k] , '0' , N  ) ;  }
   matrixf[xmax][ymax] = '1' ;
   while ( 1 )  {
      for ( k=0 ; k<N ; ++k )  memset ( mat[k] , '0' , N  ) ;
      for ( k = 0 ; k <=  pointer_curent_qu ; k++ )  {
          if ( inner[curent_qu[k][0]][curent_qu[k][1]] == '1' )  continue ;

          if ( curent_qu[k][0] -1 >= 0  &&
              matrixf[curent_qu[k][0] -1][curent_qu[k][1]] == '0' &&
              matrix[curent_qu[k][0]][curent_qu[k][1]] ==
              matrix [curent_qu[k][0] -1][curent_qu[k][1]] )  {
                ++pointer_curent_qu ;
                curent_qu[pointer_curent_qu][0] = curent_qu[k][0] -1 ;
                curent_qu[pointer_curent_qu][1] = curent_qu[k][1] ;
                matrixf[curent_qu[k][0] -1][curent_qu[k][1]] = '1' ;

            }
            if ( curent_qu[k][0] + 1 < N  &&
               matrixf[curent_qu[k][0] + 1][curent_qu[k][1]] == '0'  &&
               matrix[curent_qu[k][0]][curent_qu[k][1]] ==
               matrix[curent_qu[k][0] + 1][curent_qu[k][1]] )  {
                 ++pointer_curent_qu ;
                 curent_qu[pointer_curent_qu][0] = curent_qu[k][0]  + 1 ;
                 curent_qu[pointer_curent_qu][1] = curent_qu[k][1] ;
                 matrixf[curent_qu[k][0] + 1][curent_qu[k][1]] = '1' ;

            }
            if ( curent_qu[k][1] + 1 < N  &&
                matrixf[curent_qu[k][0] ][curent_qu[k][1]+1] == '0'   &&
                matrix[curent_qu[k][0]][curent_qu[k][1]] ==
                matrix[curent_qu[k][0] ][curent_qu[k][1]+1] )  {
                     ++pointer_curent_qu ;
                     curent_qu[pointer_curent_qu][0] = curent_qu[k][0] ;
                     curent_qu[pointer_curent_qu][1] = curent_qu[k][1] + 1;
                     matrixf[curent_qu[k][0] ][curent_qu[k][1] + 1 ] = '1' ;

            }
            if ( curent_qu[k][1] -1 >= 0 &&
                  matrixf[curent_qu[k][0] ][curent_qu[k][1]-1] == '0'  &&
                  matrix[curent_qu[k][0]][curent_qu[k][1]] ==
                  matrix[curent_qu[k][0]][curent_qu[k][1]-1] )  {
                      ++pointer_curent_qu ;
                      curent_qu[pointer_curent_qu][0] = curent_qu[k][0]  ;
                      curent_qu[pointer_curent_qu][1] = curent_qu[k][1] -1 ;
                      matrixf[curent_qu[k][0] ][curent_qu[k][1]-1] = '1' ;
            }


          if ( curent_qu[k][0] -1 >= 0  &&
              matrix[curent_qu[k][0]][curent_qu[k][1]] !=
              matrix [curent_qu[k][0] -1][curent_qu[k][1]] )  continue ;
          if ( curent_qu[k][0] + 1 < N  &&
               matrix[curent_qu[k][0]][curent_qu[k][1]] !=
               matrix[curent_qu[k][0] + 1][curent_qu[k][1]] )  continue ;
          if ( curent_qu[k][1] + 1 < N  &&
                matrix[curent_qu[k][0]][curent_qu[k][1]] !=
                matrix[curent_qu[k][0] ][curent_qu[k][1]+1] )  continue ;
          if ( curent_qu[k][1] -1 >= 0 &&
                  matrix[curent_qu[k][0]][curent_qu[k][1]] !=
                  matrix[curent_qu[k][0]][curent_qu[k][1]-1] ) continue ;


            inner[curent_qu[k][0]][curent_qu[k][1]] = '1' ;
      }   // end of curent_qu

      if ( pointer_curent_qu >= ( N*N -1 ))   break  ; // decision

      for ( k=1; k <= C ; k++ )    lengthcolor[k] = 0 ;

      for ( k=0 ; k <= pointer_curent_qu ; k++ ) {
              if ( inner[curent_qu[k][0]][curent_qu[k][1]] == '1' )  continue ;
              if ( curent_qu[k][0] -1 >= 0  && matrixf[curent_qu[k][0] -1][curent_qu[k][1]] == '0' && mat[curent_qu[k][0] -1][curent_qu[k][1]] == '0'  ) {
                   mat[curent_qu[k][0] -1][curent_qu[k][1]] = '1' ;
                    color = matrix[curent_qu[k][0] -1][curent_qu[k][1]] ;
                    ++lengthcolor[color] ;
                    pointer_temp_qu = 0 ;
                    temp_qu[pointer_temp_qu][0] = curent_qu[k][0] -1 ;
                    temp_qu[pointer_temp_qu][1] = curent_qu[k][1]  ;
                    for ( l = 0 ; l <=  pointer_temp_qu ; l++ ) {
                        if (temp_qu[l][0] -1 >= 0  &&
                    	    matrixf[temp_qu[l][0] -1][temp_qu[l][1]] == '0' && mat[temp_qu[l][0] -1][temp_qu[l][1]] == '0' &&
                    	    color == matrix [temp_qu[l][0] -1][temp_qu[l][1]] )  {
                            ++pointer_temp_qu ;
                        	temp_qu[pointer_temp_qu][0] = temp_qu[l][0] -1 ;
                        	temp_qu[pointer_temp_qu][1] = temp_qu[l][1] ;
                        	mat[temp_qu[l][0] -1][temp_qu[l][1]] = '1' ;
                            ++lengthcolor[color] ;
                        }
                        if ( temp_qu[l][0] + 1 < N  &&
                    	     matrixf[temp_qu[l][0] + 1][temp_qu[l][1]] == '0'  && mat [temp_qu[l][0] + 1][temp_qu[l][1]] == '0' &&
                    	     color ==  matrix[temp_qu[l][0] + 1][temp_qu[l][1]] )  {
                             ++pointer_temp_qu ;
                             temp_qu[pointer_temp_qu][0] = temp_qu[l][0]  + 1 ;
                             temp_qu[pointer_temp_qu][1] = temp_qu[l][1] ;
                             mat[temp_qu[l][0] + 1][temp_qu[l][1]] = '1' ;
                             ++lengthcolor[color] ;
                        }
                        if ( temp_qu[l][1] + 1 < N  &&
                    	    matrixf[temp_qu[l][0] ][temp_qu[l][1]+1] == '0'   && mat[temp_qu[l][0] ][temp_qu[l][1]+1] == '0' &&
                    	    color ==  matrix[temp_qu[l][0] ][temp_qu[l][1]+1] )  {
                            ++pointer_temp_qu ;
                            temp_qu[pointer_temp_qu][0] = temp_qu[l][0] ;
                            temp_qu[pointer_temp_qu][1] = temp_qu[l][1] + 1;
                            mat[temp_qu[l][0] ][temp_qu[l][1] + 1 ] = '1' ;
                            ++lengthcolor[color] ;
                        }
                        if ( temp_qu[l][1] -1 >= 0 &&
                            matrixf[temp_qu[l][0] ][temp_qu[l][1]-1] == '0'  &&  mat[temp_qu[l][0] ][temp_qu[l][1]-1] == '0' &&
                            color ==  matrix[temp_qu[l][0]][temp_qu[l][1]-1] )  {
                            ++pointer_temp_qu ;
                            temp_qu[pointer_temp_qu][0] = temp_qu[l][0]  ;
                            temp_qu[pointer_temp_qu][1] = temp_qu[l][1] -1 ;
                            mat[temp_qu[l][0] ][temp_qu[l][1]-1] = '1' ;
                            ++lengthcolor[color] ;
                        }
                    }    // for temp_qu

               }    //end if
               if ( curent_qu[k][0] + 1 < N  && matrixf[curent_qu[k][0] + 1][curent_qu[k][1]] == '0' && mat[curent_qu[k][0] + 1][curent_qu[k][1]] == '0' ) {
                    mat[curent_qu[k][0] + 1][curent_qu[k][1]] = '1' ;
                    color = matrix[curent_qu[k][0] + 1][curent_qu[k][1]] ;
                    ++lengthcolor[color] ;
                    pointer_temp_qu = 0 ;
                    temp_qu[pointer_temp_qu][0] = curent_qu[k][0]  + 1 ;
                    temp_qu[pointer_temp_qu][1] = curent_qu[k][1]  ;
                    for ( l = 0 ; l <=  pointer_temp_qu ; l++ ) {
                        if (temp_qu[l][0] -1 >= 0  &&
                    	    matrixf[temp_qu[l][0] -1][temp_qu[l][1]] == '0' && mat[temp_qu[l][0] -1][temp_qu[l][1]] == '0' &&
                    	    color == matrix [temp_qu[l][0] -1][temp_qu[l][1]] )  {
                            ++pointer_temp_qu ;
                        	temp_qu[pointer_temp_qu][0] = temp_qu[l][0] -1 ;
                        	temp_qu[pointer_temp_qu][1] = temp_qu[l][1] ;
                        	mat[temp_qu[l][0] -1][temp_qu[l][1]] = '1' ;
                            ++lengthcolor[color] ;
                        }
                        if ( temp_qu[l][0] + 1 < N  &&
                    	     matrixf[temp_qu[l][0] + 1][temp_qu[l][1]] == '0'  &&  mat[temp_qu[l][0] + 1][temp_qu[l][1]] == '0' &&
                    	     color ==  matrix[temp_qu[l][0] + 1][temp_qu[l][1]] )  {
                             ++pointer_temp_qu ;
                             temp_qu[pointer_temp_qu][0] = temp_qu[l][0]  + 1 ;
                             temp_qu[pointer_temp_qu][1] = temp_qu[l][1] ;
                             mat[temp_qu[l][0] + 1][temp_qu[l][1]] = '1' ;
                             ++lengthcolor[color] ;
                        }
                        if ( temp_qu[l][1] + 1 < N  &&
                    	    matrixf[temp_qu[l][0] ][temp_qu[l][1]+1] == '0'   && mat[temp_qu[l][0] ][temp_qu[l][1]+1] == '0'  &&
                    	    color ==  matrix[temp_qu[l][0] ][temp_qu[l][1]+1] )  {
                            ++pointer_temp_qu ;
                            temp_qu[pointer_temp_qu][0] = temp_qu[l][0] ;
                            temp_qu[pointer_temp_qu][1] = temp_qu[l][1] + 1;
                            mat[temp_qu[l][0] ][temp_qu[l][1] + 1 ] = '1' ;
                            ++lengthcolor[color] ;
                        }
                        if ( temp_qu[l][1] -1 >= 0 &&
                            matrixf[temp_qu[l][0] ][temp_qu[l][1]-1] == '0'  && mat[temp_qu[l][0] ][temp_qu[l][1]-1] == '0'  &&
                            color ==  matrix[temp_qu[l][0]][temp_qu[l][1]-1] )  {
                            ++pointer_temp_qu ;
                            temp_qu[pointer_temp_qu][0] = temp_qu[l][0]  ;
                            temp_qu[pointer_temp_qu][1] = temp_qu[l][1] -1 ;
                            mat[temp_qu[l][0] ][temp_qu[l][1]-1] = '1' ;
                            ++lengthcolor[color] ;
                        }
                    }    // for temp_qu

               }    //end if
               if ( curent_qu[k][1] -1 >= 0  && matrixf[curent_qu[k][0] ][curent_qu[k][1] -1 ] == '0'  && mat[curent_qu[k][0] ][curent_qu[k][1] -1 ] == '0' ) {
                    mat[curent_qu[k][0] ][curent_qu[k][1]- 1] = '1' ;
                    color = matrix[curent_qu[k][0]][curent_qu[k][1] - 1] ;
                    ++lengthcolor[color] ;
                    pointer_temp_qu = 0 ;
                    temp_qu[pointer_temp_qu][0] = curent_qu[k][0]  ;
                    temp_qu[pointer_temp_qu][1] = curent_qu[k][1] -1 ;
                    for ( l = 0 ; l <=  pointer_temp_qu ; l++ ) {
                        if (temp_qu[l][0] -1 >= 0  &&
                    	    matrixf[temp_qu[l][0] -1][temp_qu[l][1]] == '0' && mat[temp_qu[l][0] -1][temp_qu[l][1]] == '0' &&
                    	    color == matrix [temp_qu[l][0] -1][temp_qu[l][1]] )  {
                            ++pointer_temp_qu ;
                        	temp_qu[pointer_temp_qu][0] = temp_qu[l][0] -1 ;
                        	temp_qu[pointer_temp_qu][1] = temp_qu[l][1] ;
                        	mat[temp_qu[l][0] -1][temp_qu[l][1]] = '1' ;
                            ++lengthcolor[color] ;
                        }
                        if ( temp_qu[l][0] + 1 < N  &&
                    	     matrixf[temp_qu[l][0] + 1][temp_qu[l][1]] == '0'  && mat[temp_qu[l][0] + 1][temp_qu[l][1]] == '0'  &&
                    	     color ==  matrix[temp_qu[l][0] + 1][temp_qu[l][1]] )  {
                             ++pointer_temp_qu ;
                             temp_qu[pointer_temp_qu][0] = temp_qu[l][0]  + 1 ;
                             temp_qu[pointer_temp_qu][1] = temp_qu[l][1] ;
                             mat[temp_qu[l][0] + 1][temp_qu[l][1]] = '1' ;
                             ++lengthcolor[color] ;
                        }
                        if ( temp_qu[l][1] + 1 < N  &&
                    	    matrixf[temp_qu[l][0] ][temp_qu[l][1]+1] == '0'   && mat[temp_qu[l][0] ][temp_qu[l][1]+1] == '0'   &&
                    	    color ==  matrix[temp_qu[l][0] ][temp_qu[l][1]+1] )  {
                            ++pointer_temp_qu ;
                            temp_qu[pointer_temp_qu][0] = temp_qu[l][0] ;
                            temp_qu[pointer_temp_qu][1] = temp_qu[l][1] + 1;
                            mat[temp_qu[l][0] ][temp_qu[l][1] + 1 ] = '1' ;
                            ++lengthcolor[color] ;
                        }
                        if ( temp_qu[l][1] -1 >= 0 &&
                            matrixf[temp_qu[l][0] ][temp_qu[l][1]-1] == '0'  && mat[temp_qu[l][0] ][temp_qu[l][1]-1] == '0'  &&
                            color ==  matrix[temp_qu[l][0]][temp_qu[l][1]-1] )  {
                            ++pointer_temp_qu ;
                            temp_qu[pointer_temp_qu][0] = temp_qu[l][0]  ;
                            temp_qu[pointer_temp_qu][1] = temp_qu[l][1] -1 ;
                            mat[temp_qu[l][0] ][temp_qu[l][1]-1] = '1' ;
                            ++lengthcolor[color] ;
                        }
                    }    // for temp_qu

                }    //end if
               if ( curent_qu[k][1] +1 < N  && matrixf[curent_qu[k][0] ][curent_qu[k][1] + 1] == '0' && mat[curent_qu[k][0] ][curent_qu[k][1] + 1] == '0' ) {
                    mat[curent_qu[k][0] ][curent_qu[k][1]+1] = '1' ;
                    color = matrix[curent_qu[k][0] ][curent_qu[k][1]+1] ;
                    ++lengthcolor[color] ;
                    pointer_temp_qu = 0 ;
                    temp_qu[pointer_temp_qu][0] = curent_qu[k][0]  ;
                    temp_qu[pointer_temp_qu][1] = curent_qu[k][1] +1 ;
                    for ( l = 0 ; l <=  pointer_temp_qu ; l++ ) {
                        if (temp_qu[l][0] -1 >= 0  &&
                    	    matrixf[temp_qu[l][0] -1][temp_qu[l][1]] == '0' && mat[temp_qu[l][0] -1][temp_qu[l][1]] == '0' &&
                    	    color == matrix [temp_qu[l][0] -1][temp_qu[l][1]] )  {
                            ++pointer_temp_qu ;
                        	temp_qu[pointer_temp_qu][0] = temp_qu[l][0] -1 ;
                        	temp_qu[pointer_temp_qu][1] = temp_qu[l][1] ;
                        	mat[temp_qu[l][0] -1][temp_qu[l][1]] = '1' ;
                            ++lengthcolor[color] ;
                        }
                        if ( temp_qu[l][0] + 1 < N  &&
                    	     matrixf[temp_qu[l][0] + 1][temp_qu[l][1]] == '0'  && mat[temp_qu[l][0] + 1][temp_qu[l][1]] == '0'  &&
                    	     color ==  matrix[temp_qu[l][0] + 1][temp_qu[l][1]] )  {
                             ++pointer_temp_qu ;
                             temp_qu[pointer_temp_qu][0] = temp_qu[l][0]  + 1 ;
                             temp_qu[pointer_temp_qu][1] = temp_qu[l][1] ;
                             mat[temp_qu[l][0] + 1][temp_qu[l][1]] = '1' ;
                             ++lengthcolor[color] ;
                        }
                        if ( temp_qu[l][1] + 1 < N  &&
                    	    matrixf[temp_qu[l][0] ][temp_qu[l][1]+1] == '0'   && mat[temp_qu[l][0] ][temp_qu[l][1]+1] == '0'   &&
                    	    color ==  matrix[temp_qu[l][0] ][temp_qu[l][1]+1] )  {
                            ++pointer_temp_qu ;
                            temp_qu[pointer_temp_qu][0] = temp_qu[l][0] ;
                            temp_qu[pointer_temp_qu][1] = temp_qu[l][1] + 1;
                            mat[temp_qu[l][0] ][temp_qu[l][1] + 1 ] = '1' ;
                            ++lengthcolor[color] ;
                        }
                        if ( temp_qu[l][1] -1 >= 0 &&
                            matrixf[temp_qu[l][0] ][temp_qu[l][1]-1] == '0'  && mat[temp_qu[l][0] ][temp_qu[l][1]-1] == '0'  &&
                            color ==  matrix[temp_qu[l][0]][temp_qu[l][1]-1] )  {
                            ++pointer_temp_qu ;
                            temp_qu[pointer_temp_qu][0] = temp_qu[l][0]  ;
                            temp_qu[pointer_temp_qu][1] = temp_qu[l][1] -1 ;
                            mat[temp_qu[l][0] ][temp_qu[l][1]-1] = '1' ;
                            ++lengthcolor[color] ;
                        }
                    }    // for temp_qu

                }    //end if



            }  // end of for curent_qu


            maxcurentcolor = 0 ;  maxcolorlength = 0 ;
            for ( k=1 ; k <=  C ; ++k )
               if ( maxcolorlength <  lengthcolor[k] ) {
                   maxcolorlength = lengthcolor[k] ;
                   maxcurentcolor = k ;
               }

            // fill with maxcolorlength

             decision [count] = maxcurentcolor ;
             ++count ;


             for ( k = 0;k <= pointer_curent_qu ; k++ )
                 matrix[curent_qu[k][0]][curent_qu[k][1]] = maxcurentcolor ;


/*   dump matrix

             for ( i = 0 ; i < N ; i++ )    {
                cout << endl ;
                for ( j = 0 ; j < N ; j++ )
                 cout << matrix[i][j] << " " ;

             }
             cout << endl << endl ;
*/


   }   // end of while


    decision[0] = count - 3 ;


    fout.open ( "flood-it.out" ) ;
    if ( fout.is_open()  ) {
        fout << decision[0] << endl << decision[1] << " " << decision[2] << endl ;
        for ( i = 0 ; i < decision[0] ; ++i )
            fout <<  decision [ i + 3 ] << endl ;
        fout.close() ;
    }

/*   dump decision
    cout << "N , C  "  << N << " , " << C << endl ;
    cout << "decision  " << decision[0] << endl ;
    cout << "xmax , ymax " << xmax << " , " << ymax <<  endl ;
    cout << "constN   " << constN << endl ;
    cout << "last color  " << decision [decision[0] + 2 ] << endl ;
*/
    for ( i = 0 ; i < N ; i++ ) {
        delete[] matrix[i] ;
        delete[] matrixf[i] ;
        delete[] mat[i] ;
        delete[] inner[i] ;

    }
    for ( i = 0 ; i < N * N ; i++ ) {
        delete[] curent_qu[i] ;
        delete[] temp_qu[i] ;
    }

    delete[] matrix ;
    delete[] matrixf ;
    delete[] mat ;
    delete[] inner ;
    delete[] curent_qu ;
    delete[] temp_qu ;
    delete[] decision  ;
    delete[] lengthcolor  ;


    return 0;
}


